package game
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.system.Security;
	
	import game.playState.PlayState;
	
	import net.flashpunk.Engine;
	import net.flashpunk.FP;
	import game.startState.StartState;
	
	//[SWF(width="800", height="600", backgroundColor="#ffffff", frameRate="60")]
	//[Frame(factoryClass="game.Preload")]
	public class Main extends Engine
	{
		public function Main() {
			super(800, 600, 60, false);
			FP.screen.color = 0xFFFFFF;
			
			if (root == null)
			{
				addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			}
			else
			{
				loadKongregateStuff();
			}
		}
		
		protected function onAddedToStage(event:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			loadKongregateStuff();
		}
		
		protected function loadKongregateStuff():void
		{
			// Do kongregate stuff
			
			// Pull the API path from the FlashVars
			var paramObj:Object = LoaderInfo(root.loaderInfo).parameters;
			
			// The API path. The "shadow" API will load if testing locally. 
			var apiPath:String = paramObj.kongregate_api_path || "http://www.kongregate.com/flash/API_AS3_Local.swf";
			
			// Allow the API access to this SWF
			Security.allowDomain(apiPath);
			
			// Load the API
			var request:URLRequest = new URLRequest(apiPath);
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
			loader.load(request);
			this.addChild(loader);
			
			//start();
		}

		// This function is called when loading is complete
		protected function loadComplete(event:Event):void {
			// Save Kongregate API reference
			//Constants.kongregate = event.target.content;
			
			// Connect to the back-end
			//Constants.kongregate.services.connect();
			
			start();
		}
		
		protected function start():void {
			if (Constants.DEBUG)
			{
				FP.world = new PlayState(false, 1);
			}
			else
			{
				FP.world = new StartState();
			}
		}
	}
}