package game.playState
{
	import game.Constants;
	
	import net.flashpunk.graphics.TiledImage;
	
	public class Tile extends PlaystateEntity {
		protected var _tileX:int;
		protected var _tileY:int;
		protected var _tileIndex:uint;
		protected var tilesImage:TiledImage;
		protected var tilesImageOffsetX:int;
		protected var tilesImageOffsetY:int;
		
		public function get tileX():int { return _tileX; }
		public function get tileY():int { return _tileY; }
		public function get tileIndex():uint { return _tileIndex; }
		
		public function Tile(playState:PlayState, tileX:int, tileY:int, tilesImage:TiledImage, tilesImageCountX:uint, tileIndex:int) {
			super(playState, tileX * Constants.TILE_WIDTH, tileY * Constants.TILE_HEIGHT);
			
			this.tilesImage = tilesImage;
			_tileIndex = tileIndex;

			tilesImageOffsetX = -(tileIndex % tilesImageCountX) * tilesImage.width;
			tilesImageOffsetY = -Math.floor(tileIndex / tilesImageCountX) * tilesImage.height;
			
			_tileX = tileX;
			_tileY = tileY;
			
			graphic = tilesImage;
			setHitboxTo(tilesImage);
			
			type = Constants.TYPE_WALL;
			layer = Constants.LAYER_TILES;
		}

		public override function render():void {
			tilesImage.setOffset(tilesImageOffsetX, tilesImageOffsetY);
			super.render();
		}
	}
}