package game.playState
{
	import game.Constants;
	
	import net.flashpunk.Graphic;
	import net.flashpunk.Mask;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.tweens.misc.VarTween;
	
	public class VanishingText extends PlaystateEntity
	{
		protected var text:Text;
		public function VanishingText(str:String, playState:PlayState, x:Number, y:Number, layer:int, color:uint = 0xFFFFFF)
		{
			super(playState, x, y, graphic, mask);
			this.text = new Text(str);
			text.color = color;
			text.outlineColor = 0;
			text.outlineStrength = 4;
			
			this.addGraphic(this.text);
			var fadeOutTween:VarTween = new VarTween(fadedOut);
			fadeOutTween.tween(this.text, "alpha", 0, Constants.TEXT_FADE_OUT_SPEED);			
			addTween(fadeOutTween);
			
			x -= text.width / 2;
			
			this.layer = layer;
		}
		
		public function fadedOut():void 
		{
			playState.remove(this);
		}
	}
}